package fr.iut.pm.movieapplication.repository

import android.util.Log
import fr.iut.pm.movieapplication.api.RetrofitInstance
import fr.iut.pm.movieapplication.api.dtos.PopularDTO
import fr.iut.pm.movieapplication.model.media.MediaResult
import fr.iut.pm.movieapplication.model.media.movie.Movie
import fr.iut.pm.movieapplication.utils.MediaResultMapper
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response

class MovieRepository() {

    fun getPopularMovies(page : Int = 1 ,callback: (List<Movie>) -> Unit ) {

        val listMovie : MutableList<Movie> = mutableListOf()

        RetrofitInstance.api.getPopularMovies(page = page).enqueue(object :
            Callback<PopularDTO> {
            override fun onResponse(call: Call<PopularDTO>, response: Response<PopularDTO>) {
                if (response.isSuccessful) {
                    Log.d("List :", response.body().toString())
                    val popularDTO = response.body()
                    val listMoviesDTO = popularDTO?.results
                    listMoviesDTO?.forEach {

                        val movie = MediaResultMapper.mapToMovie(it)
                        listMovie.add(movie)
                        Log.d("Movie ", movie.title!! )
                    }

                }
                callback(listMovie)
            }

            override fun onFailure(call: Call<PopularDTO>, t: Throwable) {
                Log.d("Error failure", t.message.toString())
            }

        })
    }

    fun getNowPlayingMovies(page : Int = 1, callback: (List<Movie>) -> Unit) {

        val listMovie : MutableList<Movie> = mutableListOf()

        RetrofitInstance.api.getNowPlayingMovies(page = page).enqueue(object :
            Callback<PopularDTO> {
            override fun onResponse(call: Call<PopularDTO>, response: Response<PopularDTO>) {
                if (response.isSuccessful) {
                    Log.d("List :", response.body().toString())
                    val popularDTO = response.body()
                    val listMoviesDTO = popularDTO?.results
                    listMoviesDTO?.forEach {

                        val movie = MediaResultMapper.mapToMovie(it)
                        listMovie.add(movie)
                        Log.d("Movie ", movie.title!! )
                    }

                }
                callback(listMovie)
            }

            override fun onFailure(call: Call<PopularDTO>, t: Throwable) {
                Log.d("Error failure", t.message.toString())
            }

        })
    }

    fun getUpcomingMovies(page : Int = 1, callback: (List<Movie>) -> Unit) {

        val listMovie : MutableList<Movie> = mutableListOf()

        RetrofitInstance.api.getUpcomingMovies(page = page).enqueue(object :
            Callback<PopularDTO> {
            override fun onResponse(call: Call<PopularDTO>, response: Response<PopularDTO>) {
                if (response.isSuccessful) {
                    Log.d("List :", response.body().toString())
                    val popularDTO = response.body()
                    val listMoviesDTO = popularDTO?.results
                    listMoviesDTO?.forEach {

                        val movie = MediaResultMapper.mapToMovie(it)
                        listMovie.add(movie)
                        Log.d("Movie ", movie.title!! )
                    }

                }
                callback(listMovie)
            }

            override fun onFailure(call: Call<PopularDTO>, t: Throwable) {
                Log.d("Error failure", t.message.toString())
            }

        })
    }

    fun getTopRatedMovies(page : Int = 1, callback: (List<Movie>) -> Unit) {

        val listMovie : MutableList<Movie> = mutableListOf()

        RetrofitInstance.api.getTopRatedMovies(page = page).enqueue(object :
            Callback<PopularDTO> {
            override fun onResponse(call: Call<PopularDTO>, response: Response<PopularDTO>) {
                if (response.isSuccessful) {
                    Log.d("List :", response.body().toString())
                    val popularDTO = response.body()
                    val listMoviesDTO = popularDTO?.results
                    listMoviesDTO?.forEach {

                        val movie = MediaResultMapper.mapToMovie(it)
                        listMovie.add(movie)
                        Log.d("Movie ", movie.title!! )
                    }

                }
                callback(listMovie)
            }

            override fun onFailure(call: Call<PopularDTO>, t: Throwable) {
                Log.d("Error failure", t.message.toString())
            }

        })
    }


}